# random.pl
# ֘Ȁ

use Math::Random::MT;
use MIME::Base64;

require 'config.txt';

sub init_rand {
	return if ($rand_gen_initialized);

	my @seeds = &read_seeds();

	# 킪Ȃ
	if ($#seeds < 0) {
		printf STDERR "No random seeds.\n";
		exit 1;
	}

	# ̊mFp
	print STDERR "Random Seeds:\n";
	foreach (@seeds) {
		print STDERR "$_, ";
	}
	print STDERR "\n";

	$rand_gen = Math::Random::MT->new(@seeds);

	# EH[AbviEH[Abv񐔁S̍vj
	my $sum = 0;
	foreach (@seeds) {
		$sum += $_;
	}
	print STDERR "Warming-up Count: $sum\n";  # EH[Abv񐔂̊mFp

	for (my $i = 0; $i < $sum; $i++) {
		$rand_gen->rand;
	}

	$rand_gen_initialized = 1;
}

# ǂݍ
sub read_seeds {
	my @seeds = ();

	open(SEED, $path_seeds) || die "Failed to open: $path_seeds\n";
	my @bare_seeds = <SEED>;
	close(SEED);

	foreach (@bare_seeds) {
		s/^ID://;
		s/[^A-Za-z0-9+\/]//g;
		next if ($_ eq "");

		$_ = substr($_, 0, 8) if (length > 8);  # 8ɐ
		print STDERR "ID:$_\n";  # ID̊mFp

		$_ = decode_base64($_);
		@_ = unpack("C*", $_);
		push(@seeds, @_);
	}

	return @seeds;
}

&init_rand();
